#pragma once

#include "View.h"
#include "events.h"
#include "widgets.h"

#include <SDL2/SDL.h>

#include <memory>
#include <queue>
#include <vector>

class MissionSelect final : public View {
public:
  MissionSelect(SDL_Renderer* renderer);
  ~MissionSelect();

  void draw() override;
  void handle_events(std::queue<Event>& events) override;

private:
  TTF_Font* avenir;
  TTF_Font* chinat;

  std::vector<Widget*> widgets;

  std::unique_ptr<ImageWidget> ft_logo;
  std::unique_ptr<TextWidget> choose;
  std::unique_ptr<ListWidget> missions_widget;
  std::vector<std::unique_ptr<Widget>> missions;
};